function set(l) {
  var elems = {};
  l.forEach(function (e) { elems[e] = true; });
  this.elems = elems;
  this.insert = function(e) {
    this.elems[e]=true;
  };
  this.contents = function() {
    var l = [];
    for(var k in this.elems) l.push(k);
    l.sort();
    return l;
  };
  this.toString = function(e) {
    return this.contents().toString();
  };
  this.union = function(other) {
      var s = new set([]);
      s.unionFrom(this);
      s.unionFrom(other);
      return s;
  };
  this.unionFrom = function(s) {
      for(var k in s.elems) {
        this.elems[k] = true;
      }
  };
  this.minus = function(other) {
      var s = new set([]);
      s.unionFrom(this);
      s.minusFrom(other);
      return s;
  };
  this.minusFrom = function(other) {
     for(var k in other.elems) {
       delete this.elems[k];
     }
  };
  this.equals = function(other) {
    for(var k in this.elems)
      if(!other.elems.hasOwnProperty(k))
        return false;
    for(var k in other.elems)
      if(!this.elems.hasOwnProperty(k))
        return false;
    return true;
  }
};

exports.set = set;
