import System.Environment (getArgs)
import Language.SystemU.Test.Syntax
import Language.SystemU.Syntax

main = do
  [nm] <- getArgs
  src <- readFile nm
  let tm = parse src
  (a,b) <- runEquivTest tm
  let msg = if a == b 
            then "Succeeded." 
            else unlines ["Failed."
                         ,"Not alpha-equivalent: " 
                         , "   " ++ show a
                         , "   " ++ show b
                         ] 
                          
  putStrLn msg    